#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\decframe.h> 
#include <owl\floatfra.h>
#include <owl\toolbox.h> 
#include <owl\buttonga.h> 
#include "pr59_1.rc"
 
//  .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//  -.
class TCWndw : public TWindow
{
  public:
	  TCWndw (TWindow *parent, const char far *title);
  protected:
          TToolBox *toolBox;
          TFloatingFrame *toolFrame;
	  int lineWidth, lineColor;
	  BOOL button;
	  TPen *pen;
	  TClientDC *lineDC;

	  void EvLButtonUp (UINT, TPoint &point);
	  void EvLButtonDown (UINT, TPoint &point);
	  void EvMouseMove (UINT, TPoint &point);
	  LRESULT PmChangeColor (WPARAM color, LPARAM);
	  LRESULT PmChangeLine (WPARAM width, LPARAM);

	  DECLARE_RESPONSE_TABLE (TCWndw);
};

DEFINE_RESPONSE_TABLE1 (TCWndw, TWindow)
	 EV_WM_LBUTTONUP,
	 EV_WM_LBUTTONDOWN,
	 EV_WM_MOUSEMOVE,
	 EV_MESSAGE (PM_CHANGELINE, PmChangeLine),
	 EV_MESSAGE (PM_CHANGECOLOR, PmChangeColor),
END_RESPONSE_TABLE;

//   . 
class TFFrame : public TFloatingFrame
{
  public:
    TFFrame (TWindow *parent, char *title,
        TWindow *clienTWndw, BOOL ShrinkToCllent, 
        int CaptionHeight, BOOL EnablePalette);
  protected:
        void  SetupWindow(); 
        void  CmLine (WPARAM Id); 
        void  CmColor (WPARAM Id);

        DECLARE_RESPONSE_TABLE  (TFFrame);
};

DEFINE_RESPONSE_TABLE1 (TFFrame, TFloatingFrame)
	EV_COMMAND_AND_ID (CM_LINE1, CmLine),
	EV_COMMAND_AND_ID (CM_LINE2, CmLine),
	EV_COMMAND_AND_ID (CM_LINE3, CmLine),
	EV_COMMAND_AND_ID (CM_LINE4, CmLine),
	EV_COMMAND_AND_ID (CM_BLACK, CmColor),
	EV_COMMAND_AND_ID (CM_BLUE,  CmColor),
	EV_COMMAND_AND_ID (CM_RED,   CmColor),
	EV_COMMAND_AND_ID (CM_GREEN, CmColor),
	EV_COMMAND_AND_ID (CM_YELLOW,CmColor),
	EV_COMMAND_AND_ID (CM_PURPLE,CmColor),
END_RESPONSE_TABLE;

//***********************************
//   TCWndw.
//***********************************
// TCWndw::TCWndw()
//   -.
TCWndw::TCWndw (TWindow *parent, const char far *title):
		  TWindow (parent, title)
{
  TButtonGadget *b; 
  TSeparatorGadget *s;

  //     .
  toolBox = new TToolBox (0);
  //     . 
  b = new TButtonGadget (BMP_LINE1, CM_LINE1, TButtonGadget::Exclusive,
        TRUE, TButtonGadget::Down); 
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_LINE2, CM_LINE2, TButtonGadget::Exclusive,
        TRUE, TButtonGadget::Up); 
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_LINE3, CM_LINE3, TButtonGadget::Exclusive,
        TRUE, TButtonGadget::Up); 
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_LINE4, CM_LINE4, TButtonGadget::Exclusive,
		  TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);

  s = new TSeparatorGadget (10);
  toolBox->Insert (*s);
  s = new TSeparatorGadget (10);
  toolBox->Insert (*s);

  b = new TButtonGadget (BMP_BLACK, CM_BLACK, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Down);
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_BLUE, CM_BLUE, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_RED, CM_RED, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_GREEN, CM_GREEN, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_YELLOW, CM_YELLOW, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_PURPLE, CM_PURPLE, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);
  //      
  //    -.
  toolFrame = new TFFrame (this, "Toolbox", toolBox, TRUE, 
       TFloatingFrame::DefaultCaptionHeight, TRUE);
  //  .
  lineWidth = 1;
  lineColor = 0;
  button = FALSE;
  pen = NULL;
  lineDC = NULL;
}

// TCWndw::EvLButtonDown()
//     WM_LBUTTONDOWN,
//  Windows  , 
//     
//    .
void TCWndw::EvLButtonDown (UINT, TPoint &point)
{
  //     ...
  if (!button)
  {
	 //      .
	 lineDC = new TClientDC (HWindow);
	 pen = new TPen (lineColor, lineWidth, PS_SOLID);
	 lineDC->SelectObject (*pen);
	 //       .
	 SetCapture();
	 //       .
	 lineDC->MoveTo (point);
	 //    .
	 button = TRUE;
  }
}

// TCWndw::EvLButtonUp()
//     WM_LBUTTONUP,
//  Windows  , 
//     .
void TCWndw::EvLButtonUp (UINT, TPoint&)
{
  //   .
  delete lineDC;
  lineDC = NULL;
  //    .
  delete pen;
  //    .
  button = FALSE;
  //      .
  ReleaseCapture();
}

// TCWndw::EvMouseMove()
//     WM_MOUSEMOVE,
//  Windows  , 
//   .
void TCWndw::EvMouseMove (UINT, TPoint &point)
{
  //     ,  
  //    .
  if (button) lineDC->LineTo (point);
}

// TCWndw::PmChangeColor()
//      
//  PM_CHANGECOLOR    .
LRESULT TCWndw::PmChangeColor (WPARAM color, LPARAM)
{
  lineColor = color;
  return 1;
}

// TCWndw::PmChangeLine()
//      
//  PM_CHANGELINE    .
LRESULT TCWndw::PmChangeLine (WPARAM width, LPARAM)
{
  lineWidth = width;
  return 1;
}

//***********************************
//   TFFrame.
//***********************************
// TFFrame::TFFrame()
//     .
TFFrame::TFFrame (TWindow *parent, char *title, TWindow *clienTWndw, 
     BOOL shrinkToClient, int captionHeight, BOOL enablePalette) : 
     TFloatingFrame (parent, title, clienTWndw, shrinkToClient, 
        captionHeight,enablePalette)
{
}

// TFFrame::SetupWindow()
//  ,  
//   SetupWindow(), 
//     .
void TFFrame::SetupWindow() 
{
  //     SetupWindow()
  //  .
  TFloatingFrame::SetupWindow();
  //    
  //     
  //   . 
  TRect rect;
  Parent->GetWindowRect(rect); 
  SetWindowPos (0, rect.left+20, rect.top+20, 
    0, 0, SWP_NOSIZE | SWP_NOZORDER);
}

// TFFrame::CmLine()
//       
//    , 
//   -.   -  , 
//      .
void TFFrame::CmLine (WPARAM Id)
{
  Parent->PostMessage (PM_CHANGELINE, Id-100, 0);
}

// TFFrame::CmColor()
//       
//    ,  
//  -.   -,
//      .
void TFFrame::CmColor (WPARAM Id)
{
  Parent->PostMessage (PM_CHANGECOLOR, Id-200, 0);
}

//***********************************
//   TApp.
//***********************************
// TApp::InitMainWindow()
//      .
void TApp::InitMainWindow()
{
  //  -.
  TWindow *client = new TCWndw (0, 0);
  //   .
  TDecoratedFrame *frame = new TDecoratedFrame 
     (0, "  ", client);
  //     . 
  frame->AssignMenu (MENU_1);
  //      .
  frame->Attr.X = 50;
  frame->Attr.Y = 50;
  frame->Attr.W = GetSystemMetrics (SM_CXSCREEN) / 1.5;
  frame->Attr.H = GetSystemMetrics (SM_CYSCREEN) / 1.5;
  //     . 
  SetMainWindow(frame);
} 

int OwlMain(int,char *[])
{
  return TApp().Run();
}
